# Class VulkanDebugUtilsLabelColor

java.lang.Object
com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsLabelColor

All Implemented Interfaces:
  `VulkanDebugUtilsLabelColorType`

public final class VulkanDebugUtilsLabelColor extends Object implements VulkanDebugUtilsLabelColorType
An RGBA label color.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDebugUtilsLabelColor.Builder`
  Builds instances of type `VulkanDebugUtilsLabelColor`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `float`
  `alpha()`
  `float`
  `blue()`
  `static VulkanDebugUtilsLabelColor.Builder`
  `builder()`
  Creates a builder for `VulkanDebugUtilsLabelColor`.
  `static VulkanDebugUtilsLabelColor`
  `copyOf(VulkanDebugUtilsLabelColorType instance)`
  Creates an immutable copy of a `VulkanDebugUtilsLabelColorType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDebugUtilsLabelColor` that have equal attribute values.
  `float`
  `green()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `red`, `green`, `blue`, `alpha`.
  `float`
  `red()`
  `String`
  `toString()`
  Prints the immutable value `VulkanDebugUtilsLabelColor` with attribute values.
  `final VulkanDebugUtilsLabelColor`
  `withAlpha(float value)`
  Copy the current immutable object by setting a value for the `alpha` attribute.
  `final VulkanDebugUtilsLabelColor`
  `withBlue(float value)`
  Copy the current immutable object by setting a value for the `blue` attribute.
  `final VulkanDebugUtilsLabelColor`
  `withGreen(float value)`
  Copy the current immutable object by setting a value for the `green` attribute.
  `final VulkanDebugUtilsLabelColor`
  `withRed(float value)`
  Copy the current immutable object by setting a value for the `red` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### red

    public float red()
    Specified by:
      `red` in interface `VulkanDebugUtilsLabelColorType`
    Returns:
      The red component

  - ### green

    public float green()
    Specified by:
      `green` in interface `VulkanDebugUtilsLabelColorType`
    Returns:
      The green component

  - ### blue

    public float blue()
    Specified by:
      `blue` in interface `VulkanDebugUtilsLabelColorType`
    Returns:
      The blue component

  - ### alpha

    public float alpha()
    Specified by:
      `alpha` in interface `VulkanDebugUtilsLabelColorType`
    Returns:
      The alpha component

  - ### withRed

    public final VulkanDebugUtilsLabelColor withRed(float value)
    Copy the current immutable object by setting a value for the `red` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for red
    Returns:
      A modified copy of the `this` object

  - ### withGreen

    public final VulkanDebugUtilsLabelColor withGreen(float value)
    Copy the current immutable object by setting a value for the `green` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for green
    Returns:
      A modified copy of the `this` object

  - ### withBlue

    public final VulkanDebugUtilsLabelColor withBlue(float value)
    Copy the current immutable object by setting a value for the `blue` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for blue
    Returns:
      A modified copy of the `this` object

  - ### withAlpha

    public final VulkanDebugUtilsLabelColor withAlpha(float value)
    Copy the current immutable object by setting a value for the `alpha` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for alpha
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDebugUtilsLabelColor` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `red`, `green`, `blue`, `alpha`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDebugUtilsLabelColor` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanDebugUtilsLabelColor copyOf(VulkanDebugUtilsLabelColorType instance)
    Creates an immutable copy of a `VulkanDebugUtilsLabelColorType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDebugUtilsLabelColor instance

  - ### builder

    public static VulkanDebugUtilsLabelColor.Builder builder()
    Creates a builder for `VulkanDebugUtilsLabelColor`.

         VulkanDebugUtilsLabelColor.builder()
            .setRed(float) // required red
            .setGreen(float) // required green
            .setBlue(float) // required blue
            .setAlpha(float) // required alpha
            .build();

    Returns:
      A new VulkanDebugUtilsLabelColor builder